module Ubc.Parse.Syntax.TypeExpression
( TypeExpression(..)
, parseTypeExpression
)
where
import Ubc.Parse.Syntax.VariableType (VariableType)
import Ubc.Parse.Syntax.Data.Struct (Struct)
import Text.Parsec (choice, ParsecT)
import qualified Ubc.Parse.Syntax.Language as UbcLanguage
import qualified Ubc.Parse.Syntax.VariableType as VariableType
import Control.Monad ((<$!>))
import qualified Ubc.Parse.Syntax.Struct as Struct
import Ubc.Parse.Syntax.ParserState (ParserState)

data TypeExpression = TypeAlias VariableType
        | StructExpression Struct

parseTypeExpression :: Monad m => ParsecT String ParserState m TypeExpression
parseTypeExpression = choice
                        [ TypeAlias . VariableType.fromString <$!> UbcLanguage.typeName
                        , StructExpression <$!> Struct.parseStruct
                        ]
